// Die Zahlen (Hack....)

#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "H:/projekt/sdl/sdl.h"

void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to set */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        *p = pixel;
        break;

    case 2:
        *(Uint16 *)p = pixel;
        break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        } else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;

    case 4:
        *(Uint32 *)p = pixel;
        break;
    }
}
//10 zahlen, 8 hoch 5 breit
int zahl[8][12][5] =
{
	{{1,1,1,1,1}, {0,0,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,0,0}, {0,0,0,0,0}},
	{{1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {1,0,0,0,0}, {1,0,0,0,0}, {0,0,0,0,1}, {1,0,0,0,1}, {1,0,0,0,1}, {0,0,0,0,0}, {0,0,0,0,0}},
	{{1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {1,0,0,0,0}, {1,0,0,0,0}, {0,0,0,1,0}, {1,0,0,0,1}, {1,0,0,0,1}, {0,0,0,0,0}, {0,0,0,0,0}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,1,1,1,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,0,0}, {1,1,1,1,1}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,0}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {0,0,0,1,0}, {1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,0}, {0,0,0,0,0}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,0}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {0,0,0,1,0}, {1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,0}, {0,0,0,0,0}}, 
	{{1,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,0}, {0,0,0,0,1}, {0,0,0,0,1}, {0,0,0,0,1}, {1,0,0,0,1}, {0,0,0,1,0}, {1,0,0,0,1}, {0,0,0,0,1}, {0,0,0,1,1}, {0,0,0,0,0}}, 
	{{1,1,1,1,1}, {0,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,0,1}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,1,0}, {1,1,1,1,1}, {1,1,1,1,1}, {0,0,0,1,1}, {0,0,0,0,0}} 

//{,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, {,,,,}, 

};

void Output(SDL_Surface *, char *, int, Uint32);

void Zahlenausgabe(SDL_Surface *screen, double C, double D, double l, Uint32 color)
{
	int decimal, sign, x;
	char Cs[30], Ds[30], ls[30], vorz[30], *buffer;
	SDL_Rect dest;
	
	buffer = _ecvt(C, 10, &decimal, &sign );
	if (decimal<0) decimal =0; // okay, beschiss...
	strcpy(Cs, buffer);
	Cs[decimal]='.';
	strcpy(&Cs[decimal+1], &buffer[decimal]);
	strcpy(vorz, "-");
	if (sign) strcpy(Cs, strcat(vorz, Cs));

	buffer = _ecvt(D, 10, &decimal, &sign );
	if (decimal<0) decimal =0; // okay, beschiss...
	strcpy(Ds, buffer);
	Ds[decimal]='.';
	strcpy(&Ds[decimal+1], &buffer[decimal]);
	strcpy(vorz, "-");
	if (sign) strcpy(Ds, strcat(vorz, Ds));

	buffer = _ecvt(l, 10, &decimal, &sign );
	if (decimal<0) decimal =0; // okay, beschiss...
	strcpy(ls, buffer);
	ls[decimal]='.';
	strcpy(&ls[decimal+1], &buffer[decimal]);
	strcpy(vorz, "-");
	if (sign) strcpy(ls, strcat(vorz, ls));


	dest.x = 100; dest.y = 10; dest.h = 20; dest.w = 400;
	SDL_FillRect(screen, &dest, 0);
	
	x=120;
	Output(screen, Cs, x, color);
	x+=120;
	Output(screen, Ds, x, color);
	x+=120;
	Output(screen, ls, x, color);
}

void Output(SDL_Surface *screen, char *String, int xpos, Uint32 color)
{
	int i,j,k,x;
	SDL_Rect dest;
	dest.x = xpos; dest.y = 10;
	dest.y+=5;
	dest.x+=10;

	x=0;
	while (1)
	{
		switch (String[x])
		{
		case '0': 	k=0; break;
		case '1': 	k=1; break;
		case '2': 	k=2; break;
		case '3': 	k=3; break;
		case '4': 	k=4; break;
		case '5': 	k=5; break;
		case '6': 	k=6; break;
		case '7': 	k=7; break;
		case '8': 	k=8; break;
		case '9': 	k=9; break;
		case '.': 	k=10; break;
		case '-': 	k=11; break;
		case 0:		k=-1; break;
		default:	k=-2; break;
		}
		x++;
		if (k==-1) break;
		if (k==-2) continue;

		for (i=0; i<8; i++)
		{
			for (j=0; j<5; j++)
			{
				if(zahl[i][k][j]) putpixel(screen, dest.x+j, dest.y+i, color);
			}
		} //for i
		dest.x+=6;

	} //while
}